{-# LANGUAGE NoImplicitPrelude       #-}

module Main where

import Data.Set as Set
import Data.String.Conversions (cs)
import System.Environment (getArgs, withArgs)
import Data.Text (Text)
import Graph.BAC.Clustering
import Graph.BAC.ProxemyOptim
import Graph.BAC.ProxemyOptim
import Graph.FGL
import Graph.Tools.Import
import Graph.Types
import Prelude (String)
import Protolude
import qualified Data.IntMap                       as Dict
import qualified Data.List as List
import qualified Eigen.Matrix as Matrix
import qualified Eigen.SparseMatrix as SMatrix
import qualified Prelude as Prelude
import qualified Data.Graph.Inductive.PatriciaTree as DGIP

import Criterion
import Criterion.Main

setupEnv :: [String] -> IO (Dict a, Graph () ())
setupEnv [fp] = getUnlabGraph (WithFile fp)
setupEnv _    = getUnlabGraph Random

main :: IO ()
main = do
  fp <- getArgs

  withArgs [] $
    defaultMain
      [ env (snd <$> setupEnv fp) $ \ ~g ->
        bench "bench" (nf (\ x -> withG x (parts . clusteringOptim 3 Conf)) g)
      ]
